public class SymbolTableEntry {
	private String name;
	private int address;
	private int type;
	private int level;
	private int idclass;
	private SymbolTable paramList = new SymbolTable();
	private SymbolTableEntry paramList2[] = new SymbolTableEntry[10];
	private int paramIndex = 0;
	private Object special = null;

	public SymbolTableEntry(String name, int address, int type, int level, int idclass) {
		this.name = name;
		this.address = address;
		this.type = type;
		this.level = level;
		this.idclass = idclass;
	}

	public String getName() { return name; }
	public int getAddress() { return address; }
	public int getType() { return type; }
	public int getLevel() { return level; }
	public int getIdClass() { return idclass; }
	public int getParamIndex() { return paramIndex; }
	public void incParamIndex() { paramIndex++; }
	public SymbolTable getParamList() { return paramList; }
	public SymbolTableEntry getParamList2(int i) { return paramList2[i]; }
	public void setParamList2(int i, SymbolTableEntry entry) { paramList2[i] = entry; }

	public Object getSpecial() { return special; }
	public void setSpecial(Object special) {
		this.special = special;
	}

	public String toString() {
		return address + " " + type + " " + level + " " + idclass;
	}
}
