/* This file was generated by SableCC (http://www.sablecc.org/). */

package minako.parser;

import minako.lexer.*;
import minako.node.*;
import minako.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

@SuppressWarnings("nls")
public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected ArrayList nodeList;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    public Parser(@SuppressWarnings("hiding") Lexer lexer)
    {
        this.lexer = lexer;
    }

    protected void filter() throws ParserException, LexerException, IOException
    {
        // Empty body
    }

    private void push(int numstate, ArrayList listNode, boolean hidden) throws ParserException, LexerException, IOException
    {
        this.nodeList = listNode;

        if(!hidden)
        {
            filter();
        }

        if(!this.stack.hasNext())
        {
            this.stack.add(new State(numstate, this.nodeList));
            return;
        }

        State s = (State) this.stack.next();
        s.state = numstate;
        s.nodes = this.nodeList;
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private int state()
    {
        State s = (State) this.stack.previous();
        this.stack.next();
        return s.state;
    }

    private ArrayList pop()
    {
        return ((State) this.stack.previous()).nodes;
    }

    private int index(Switchable token)
    {
        this.converter.index = -1;
        token.apply(this.converter);
        return this.converter.index;
    }

    @SuppressWarnings("unchecked")
    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, true);
        List<Node> ign = null;
        while(true)
        {
            while(index(this.lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new LinkedList<Node>();
                }

                ign.add(this.lexer.next());
            }

            if(ign != null)
            {
                this.ignoredTokens.setIn(this.lexer.peek(), ign);
                ign = null;
            }

            this.last_pos = this.lexer.peek().getPos();
            this.last_line = this.lexer.peek().getLine();
            this.last_token = this.lexer.peek();

            int index = index(this.lexer.peek());
            this.action[0] = Parser.actionTable[state()][0][1];
            this.action[1] = Parser.actionTable[state()][0][2];

            int low = 1;
            int high = Parser.actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < Parser.actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > Parser.actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    this.action[0] = Parser.actionTable[state()][middle][1];
                    this.action[1] = Parser.actionTable[state()][middle][2];
                    break;
                }
            }

            switch(this.action[0])
            {
                case SHIFT:
		    {
		        ArrayList list = new ArrayList();
		        list.add(this.lexer.next());
                        push(this.action[1], list, false);
                    }
		    break;
                case REDUCE:
                    switch(this.action[1])
                    {
                    case 0: /* reduce AAprogram1Program */
		    {
			ArrayList list = new0();
			push(goTo(0), list, false);
		    }
		    break;
                    case 1: /* reduce AAprogram2Program */
		    {
			ArrayList list = new1();
			push(goTo(0), list, false);
		    }
		    break;
                    case 2: /* reduce ADeclProgram1 */
		    {
			ArrayList list = new2();
			push(goTo(1), list, false);
		    }
		    break;
                    case 3: /* reduce AFuncdefProgram1 */
		    {
			ArrayList list = new3();
			push(goTo(1), list, false);
		    }
		    break;
                    case 4: /* reduce AAfunctiondefinition1Functiondefinition */
		    {
			ArrayList list = new4();
			push(goTo(2), list, false);
		    }
		    break;
                    case 5: /* reduce AAfunctiondefinition2Functiondefinition */
		    {
			ArrayList list = new5();
			push(goTo(2), list, false);
		    }
		    break;
                    case 6: /* reduce AAparameterlist1Parameterlist */
		    {
			ArrayList list = new6();
			push(goTo(3), list, false);
		    }
		    break;
                    case 7: /* reduce AAparameterlist2Parameterlist */
		    {
			ArrayList list = new7();
			push(goTo(3), list, false);
		    }
		    break;
                    case 8: /* reduce AParamlisttemp */
		    {
			ArrayList list = new8();
			push(goTo(4), list, false);
		    }
		    break;
                    case 9: /* reduce AEmptyFunctioncall */
		    {
			ArrayList list = new9();
			push(goTo(5), list, false);
		    }
		    break;
                    case 10: /* reduce AAnotemptyfunctioncall1Functioncall */
		    {
			ArrayList list = new10();
			push(goTo(5), list, false);
		    }
		    break;
                    case 11: /* reduce AAnotemptyfunctioncall2Functioncall */
		    {
			ArrayList list = new11();
			push(goTo(5), list, false);
		    }
		    break;
                    case 12: /* reduce AFuncparams */
		    {
			ArrayList list = new12();
			push(goTo(6), list, false);
		    }
		    break;
                    case 13: /* reduce AAcompoundstatement1CompoundStatement */
		    {
			ArrayList list = new13();
			push(goTo(7), list, false);
		    }
		    break;
                    case 14: /* reduce AAcompoundstatement2CompoundStatement */
		    {
			ArrayList list = new14();
			push(goTo(7), list, false);
		    }
		    break;
                    case 15: /* reduce ABlockItemList */
		    {
			ArrayList list = new15();
			push(goTo(8), list, false);
		    }
		    break;
                    case 16: /* reduce ANoDanglingStatement */
		    {
			ArrayList list = new16();
			push(goTo(9), list, false);
		    }
		    break;
                    case 17: /* reduce ADanglingStatement */
		    {
			ArrayList list = new17();
			push(goTo(9), list, false);
		    }
		    break;
                    case 18: /* reduce ACompoundNoDanglingStatement */
		    {
			ArrayList list = new18();
			push(goTo(10), list, false);
		    }
		    break;
                    case 19: /* reduce AIfelseNoDanglingStatement */
		    {
			ArrayList list = new19();
			push(goTo(10), list, false);
		    }
		    break;
                    case 20: /* reduce AReturnNoDanglingStatement */
		    {
			ArrayList list = new20();
			push(goTo(10), list, false);
		    }
		    break;
                    case 21: /* reduce ADowhileNoDanglingStatement */
		    {
			ArrayList list = new21();
			push(goTo(10), list, false);
		    }
		    break;
                    case 22: /* reduce APrintfNoDanglingStatement */
		    {
			ArrayList list = new22();
			push(goTo(10), list, false);
		    }
		    break;
                    case 23: /* reduce ADeclassNoDanglingStatement */
		    {
			ArrayList list = new23();
			push(goTo(10), list, false);
		    }
		    break;
                    case 24: /* reduce AStatassNoDanglingStatement */
		    {
			ArrayList list = new24();
			push(goTo(10), list, false);
		    }
		    break;
                    case 25: /* reduce AFunccallNoDanglingStatement */
		    {
			ArrayList list = new25();
			push(goTo(10), list, false);
		    }
		    break;
                    case 26: /* reduce AIfDanglingStatement */
		    {
			ArrayList list = new26();
			push(goTo(11), list, false);
		    }
		    break;
                    case 27: /* reduce AIfelseDanglingStatement */
		    {
			ArrayList list = new27();
			push(goTo(11), list, false);
		    }
		    break;
                    case 28: /* reduce AForDanglingStatement */
		    {
			ArrayList list = new28();
			push(goTo(11), list, false);
		    }
		    break;
                    case 29: /* reduce AWhileDanglingStatement */
		    {
			ArrayList list = new29();
			push(goTo(11), list, false);
		    }
		    break;
                    case 30: /* reduce AStatassForstatement */
		    {
			ArrayList list = new30();
			push(goTo(12), list, false);
		    }
		    break;
                    case 31: /* reduce ADeclassForstatement */
		    {
			ArrayList list = new31();
			push(goTo(12), list, false);
		    }
		    break;
                    case 32: /* reduce ADowhilestatement */
		    {
			ArrayList list = new32();
			push(goTo(13), list, false);
		    }
		    break;
                    case 33: /* reduce AWhilestatement */
		    {
			ArrayList list = new33();
			push(goTo(14), list, false);
		    }
		    break;
                    case 34: /* reduce AAreturnstatement1Returnstatement */
		    {
			ArrayList list = new34();
			push(goTo(15), list, false);
		    }
		    break;
                    case 35: /* reduce AAreturnstatement2Returnstatement */
		    {
			ArrayList list = new35();
			push(goTo(15), list, false);
		    }
		    break;
                    case 36: /* reduce APrintf */
		    {
			ArrayList list = new36();
			push(goTo(16), list, false);
		    }
		    break;
                    case 37: /* reduce ANoassignDeclassignment */
		    {
			ArrayList list = new37();
			push(goTo(17), list, false);
		    }
		    break;
                    case 38: /* reduce AAssignDeclassignment */
		    {
			ArrayList list = new38();
			push(goTo(17), list, false);
		    }
		    break;
                    case 39: /* reduce ABooleanType */
		    {
			ArrayList list = new39();
			push(goTo(18), list, false);
		    }
		    break;
                    case 40: /* reduce AFloatType */
		    {
			ArrayList list = new40();
			push(goTo(18), list, false);
		    }
		    break;
                    case 41: /* reduce AIntType */
		    {
			ArrayList list = new41();
			push(goTo(18), list, false);
		    }
		    break;
                    case 42: /* reduce AVoidType */
		    {
			ArrayList list = new42();
			push(goTo(18), list, false);
		    }
		    break;
                    case 43: /* reduce AStatassignment */
		    {
			ArrayList list = new43();
			push(goTo(19), list, false);
		    }
		    break;
                    case 44: /* reduce AAssAssignment */
		    {
			ArrayList list = new44();
			push(goTo(20), list, false);
		    }
		    break;
                    case 45: /* reduce AExprAssignment */
		    {
			ArrayList list = new45();
			push(goTo(20), list, false);
		    }
		    break;
                    case 46: /* reduce ATermExpr */
		    {
			ArrayList list = new46();
			push(goTo(21), list, false);
		    }
		    break;
                    case 47: /* reduce AMinTermExpr */
		    {
			ArrayList list = new47();
			push(goTo(21), list, false);
		    }
		    break;
                    case 48: /* reduce AEqExpr */
		    {
			ArrayList list = new48();
			push(goTo(21), list, false);
		    }
		    break;
                    case 49: /* reduce ANeqExpr */
		    {
			ArrayList list = new49();
			push(goTo(21), list, false);
		    }
		    break;
                    case 50: /* reduce ALssExpr */
		    {
			ArrayList list = new50();
			push(goTo(21), list, false);
		    }
		    break;
                    case 51: /* reduce AGrtExpr */
		    {
			ArrayList list = new51();
			push(goTo(21), list, false);
		    }
		    break;
                    case 52: /* reduce ALeqExpr */
		    {
			ArrayList list = new52();
			push(goTo(21), list, false);
		    }
		    break;
                    case 53: /* reduce AGeqExpr */
		    {
			ArrayList list = new53();
			push(goTo(21), list, false);
		    }
		    break;
                    case 54: /* reduce APlusExpr */
		    {
			ArrayList list = new54();
			push(goTo(21), list, false);
		    }
		    break;
                    case 55: /* reduce AMinusExpr */
		    {
			ArrayList list = new55();
			push(goTo(21), list, false);
		    }
		    break;
                    case 56: /* reduce AOrExpr */
		    {
			ArrayList list = new56();
			push(goTo(21), list, false);
		    }
		    break;
                    case 57: /* reduce AFactorTerm */
		    {
			ArrayList list = new57();
			push(goTo(22), list, false);
		    }
		    break;
                    case 58: /* reduce AMulTerm */
		    {
			ArrayList list = new58();
			push(goTo(22), list, false);
		    }
		    break;
                    case 59: /* reduce ADivTerm */
		    {
			ArrayList list = new59();
			push(goTo(22), list, false);
		    }
		    break;
                    case 60: /* reduce AAndTerm */
		    {
			ArrayList list = new60();
			push(goTo(22), list, false);
		    }
		    break;
                    case 61: /* reduce AIntFactor */
		    {
			ArrayList list = new61();
			push(goTo(23), list, false);
		    }
		    break;
                    case 62: /* reduce AFloatFactor */
		    {
			ArrayList list = new62();
			push(goTo(23), list, false);
		    }
		    break;
                    case 63: /* reduce ABooleanFactor */
		    {
			ArrayList list = new63();
			push(goTo(23), list, false);
		    }
		    break;
                    case 64: /* reduce AFunccallFactor */
		    {
			ArrayList list = new64();
			push(goTo(23), list, false);
		    }
		    break;
                    case 65: /* reduce AIdFactor */
		    {
			ArrayList list = new65();
			push(goTo(23), list, false);
		    }
		    break;
                    case 66: /* reduce AAssFactor */
		    {
			ArrayList list = new66();
			push(goTo(23), list, false);
		    }
		    break;
                    case 67: /* reduce AId */
		    {
			ArrayList list = new67();
			push(goTo(24), list, false);
		    }
		    break;
                    case 68: /* reduce ATerminal$Program1 */
		    {
			ArrayList list = new68();
			push(goTo(25), list, true);
		    }
		    break;
                    case 69: /* reduce ANonTerminal$Program1 */
		    {
			ArrayList list = new69();
			push(goTo(25), list, true);
		    }
		    break;
                    case 70: /* reduce ATerminal$Paramlisttemp */
		    {
			ArrayList list = new70();
			push(goTo(26), list, true);
		    }
		    break;
                    case 71: /* reduce ANonTerminal$Paramlisttemp */
		    {
			ArrayList list = new71();
			push(goTo(26), list, true);
		    }
		    break;
                    case 72: /* reduce ATerminal$Funcparams */
		    {
			ArrayList list = new72();
			push(goTo(27), list, true);
		    }
		    break;
                    case 73: /* reduce ANonTerminal$Funcparams */
		    {
			ArrayList list = new73();
			push(goTo(27), list, true);
		    }
		    break;
                    case 74: /* reduce ATerminal$Statement */
		    {
			ArrayList list = new74();
			push(goTo(28), list, true);
		    }
		    break;
                    case 75: /* reduce ANonTerminal$Statement */
		    {
			ArrayList list = new75();
			push(goTo(28), list, true);
		    }
		    break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) this.lexer.next();
                        PProgram node1 = (PProgram) pop().get(0);
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(this.last_token,
                        "[" + this.last_line + "," + this.last_pos + "] " +
                        Parser.errorMessages[Parser.errors[this.action[1]]]);
            }
        }
    }



    @SuppressWarnings("unchecked")
    ArrayList new0() /* reduce AAprogram1Program */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PProgram pprogramNode1;
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        }

        pprogramNode1 = new AProgram(listNode2);
        }
	nodeList.add(pprogramNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new1() /* reduce AAprogram2Program */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PProgram pprogramNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList1.get(0);
	if(listNode2 != null)
	{
	  listNode3.addAll(listNode2);
	}
        }

        pprogramNode1 = new AProgram(listNode3);
        }
	nodeList.add(pprogramNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new2() /* reduce ADeclProgram1 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PProgram1 pprogram1Node1;
        {
            // Block
        PDeclassignment pdeclassignmentNode2;
        TSemicolon tsemicolonNode3;
        pdeclassignmentNode2 = (PDeclassignment)nodeArrayList1.get(0);
        tsemicolonNode3 = (TSemicolon)nodeArrayList2.get(0);

        pprogram1Node1 = new ADeclProgram1(pdeclassignmentNode2, tsemicolonNode3);
        }
	nodeList.add(pprogram1Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new3() /* reduce AFuncdefProgram1 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PProgram1 pprogram1Node1;
        {
            // Block
        PFunctiondefinition pfunctiondefinitionNode2;
        pfunctiondefinitionNode2 = (PFunctiondefinition)nodeArrayList1.get(0);

        pprogram1Node1 = new AFuncdefProgram1(pfunctiondefinitionNode2);
        }
	nodeList.add(pprogram1Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new4() /* reduce AAfunctiondefinition1Functiondefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctiondefinition pfunctiondefinitionNode1;
        {
            // Block
        PType ptypeNode2;
        PId pidNode3;
        TLparen tlparenNode4;
        @SuppressWarnings("unused") Object nullNode5 = null;
        TRparen trparenNode6;
        PCompoundStatement pcompoundstatementNode7;
        ptypeNode2 = (PType)nodeArrayList1.get(0);
        pidNode3 = (PId)nodeArrayList2.get(0);
        tlparenNode4 = (TLparen)nodeArrayList3.get(0);
        trparenNode6 = (TRparen)nodeArrayList4.get(0);
        pcompoundstatementNode7 = (PCompoundStatement)nodeArrayList5.get(0);

        pfunctiondefinitionNode1 = new AFunctiondefinition(ptypeNode2, pidNode3, tlparenNode4, null, trparenNode6, pcompoundstatementNode7);
        }
	nodeList.add(pfunctiondefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new5() /* reduce AAfunctiondefinition2Functiondefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctiondefinition pfunctiondefinitionNode1;
        {
            // Block
        PType ptypeNode2;
        PId pidNode3;
        TLparen tlparenNode4;
        PParameterlist pparameterlistNode5;
        TRparen trparenNode6;
        PCompoundStatement pcompoundstatementNode7;
        ptypeNode2 = (PType)nodeArrayList1.get(0);
        pidNode3 = (PId)nodeArrayList2.get(0);
        tlparenNode4 = (TLparen)nodeArrayList3.get(0);
        pparameterlistNode5 = (PParameterlist)nodeArrayList4.get(0);
        trparenNode6 = (TRparen)nodeArrayList5.get(0);
        pcompoundstatementNode7 = (PCompoundStatement)nodeArrayList6.get(0);

        pfunctiondefinitionNode1 = new AFunctiondefinition(ptypeNode2, pidNode3, tlparenNode4, pparameterlistNode5, trparenNode6, pcompoundstatementNode7);
        }
	nodeList.add(pfunctiondefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new6() /* reduce AAparameterlist1Parameterlist */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParameterlist pparameterlistNode1;
        {
            // Block
        PType ptypeNode2;
        PId pidNode3;
        LinkedList listNode4 = new LinkedList();
        ptypeNode2 = (PType)nodeArrayList1.get(0);
        pidNode3 = (PId)nodeArrayList2.get(0);
        {
            // Block
        }

        pparameterlistNode1 = new AParameterlist(ptypeNode2, pidNode3, listNode4);
        }
	nodeList.add(pparameterlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new7() /* reduce AAparameterlist2Parameterlist */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParameterlist pparameterlistNode1;
        {
            // Block
        PType ptypeNode2;
        PId pidNode3;
        LinkedList listNode5 = new LinkedList();
        ptypeNode2 = (PType)nodeArrayList1.get(0);
        pidNode3 = (PId)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null)
	{
	  listNode5.addAll(listNode4);
	}
        }

        pparameterlistNode1 = new AParameterlist(ptypeNode2, pidNode3, listNode5);
        }
	nodeList.add(pparameterlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new8() /* reduce AParamlisttemp */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParamlisttemp pparamlisttempNode1;
        {
            // Block
        TComma tcommaNode2;
        PType ptypeNode3;
        PId pidNode4;
        tcommaNode2 = (TComma)nodeArrayList1.get(0);
        ptypeNode3 = (PType)nodeArrayList2.get(0);
        pidNode4 = (PId)nodeArrayList3.get(0);

        pparamlisttempNode1 = new AParamlisttemp(tcommaNode2, ptypeNode3, pidNode4);
        }
	nodeList.add(pparamlisttempNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new9() /* reduce AEmptyFunctioncall */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctioncall pfunctioncallNode1;
        {
            // Block
        PId pidNode2;
        TLparen tlparenNode3;
        TRparen trparenNode4;
        pidNode2 = (PId)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        trparenNode4 = (TRparen)nodeArrayList3.get(0);

        pfunctioncallNode1 = new AEmptyFunctioncall(pidNode2, tlparenNode3, trparenNode4);
        }
	nodeList.add(pfunctioncallNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new10() /* reduce AAnotemptyfunctioncall1Functioncall */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctioncall pfunctioncallNode1;
        {
            // Block
        PId pidNode2;
        TLparen tlparenNode3;
        PAssignment passignmentNode4;
        LinkedList listNode5 = new LinkedList();
        TRparen trparenNode6;
        pidNode2 = (PId)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        passignmentNode4 = (PAssignment)nodeArrayList3.get(0);
        {
            // Block
        }
        trparenNode6 = (TRparen)nodeArrayList4.get(0);

        pfunctioncallNode1 = new ANotEmptyFunctioncall(pidNode2, tlparenNode3, passignmentNode4, listNode5, trparenNode6);
        }
	nodeList.add(pfunctioncallNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new11() /* reduce AAnotemptyfunctioncall2Functioncall */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctioncall pfunctioncallNode1;
        {
            // Block
        PId pidNode2;
        TLparen tlparenNode3;
        PAssignment passignmentNode4;
        LinkedList listNode6 = new LinkedList();
        TRparen trparenNode7;
        pidNode2 = (PId)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        passignmentNode4 = (PAssignment)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null)
	{
	  listNode6.addAll(listNode5);
	}
        }
        trparenNode7 = (TRparen)nodeArrayList5.get(0);

        pfunctioncallNode1 = new ANotEmptyFunctioncall(pidNode2, tlparenNode3, passignmentNode4, listNode6, trparenNode7);
        }
	nodeList.add(pfunctioncallNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new12() /* reduce AFuncparams */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFuncparams pfuncparamsNode1;
        {
            // Block
        TComma tcommaNode2;
        PAssignment passignmentNode3;
        tcommaNode2 = (TComma)nodeArrayList1.get(0);
        passignmentNode3 = (PAssignment)nodeArrayList2.get(0);

        pfuncparamsNode1 = new AFuncparams(tcommaNode2, passignmentNode3);
        }
	nodeList.add(pfuncparamsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new13() /* reduce AAcompoundstatement1CompoundStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCompoundStatement pcompoundstatementNode1;
        {
            // Block
        TLbrace tlbraceNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        TRbrace trbraceNode4;
        tlbraceNode2 = (TLbrace)nodeArrayList1.get(0);
        trbraceNode4 = (TRbrace)nodeArrayList2.get(0);

        pcompoundstatementNode1 = new ACompoundStatement(tlbraceNode2, null, trbraceNode4);
        }
	nodeList.add(pcompoundstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new14() /* reduce AAcompoundstatement2CompoundStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCompoundStatement pcompoundstatementNode1;
        {
            // Block
        TLbrace tlbraceNode2;
        PBlockItemList pblockitemlistNode3;
        TRbrace trbraceNode4;
        tlbraceNode2 = (TLbrace)nodeArrayList1.get(0);
        pblockitemlistNode3 = (PBlockItemList)nodeArrayList2.get(0);
        trbraceNode4 = (TRbrace)nodeArrayList3.get(0);

        pcompoundstatementNode1 = new ACompoundStatement(tlbraceNode2, pblockitemlistNode3, trbraceNode4);
        }
	nodeList.add(pcompoundstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new15() /* reduce ABlockItemList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PBlockItemList pblockitemlistNode1;
        {
            // Block
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode2 = new LinkedList();
        listNode2 = (LinkedList)nodeArrayList1.get(0);
	if(listNode2 != null)
	{
	  listNode3.addAll(listNode2);
	}
        }

        pblockitemlistNode1 = new ABlockItemList(listNode3);
        }
	nodeList.add(pblockitemlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new16() /* reduce ANoDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PStatement pstatementNode1;
        {
            // Block
        PNoDanglingStatement pnodanglingstatementNode2;
        pnodanglingstatementNode2 = (PNoDanglingStatement)nodeArrayList1.get(0);

        pstatementNode1 = new ANoDanglingStatement(pnodanglingstatementNode2);
        }
	nodeList.add(pstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new17() /* reduce ADanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PStatement pstatementNode1;
        {
            // Block
        PDanglingStatement pdanglingstatementNode2;
        pdanglingstatementNode2 = (PDanglingStatement)nodeArrayList1.get(0);

        pstatementNode1 = new ADanglingStatement(pdanglingstatementNode2);
        }
	nodeList.add(pstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new18() /* reduce ACompoundNoDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNoDanglingStatement pnodanglingstatementNode1;
        {
            // Block
        PCompoundStatement pcompoundstatementNode2;
        pcompoundstatementNode2 = (PCompoundStatement)nodeArrayList1.get(0);

        pnodanglingstatementNode1 = new ACompoundNoDanglingStatement(pcompoundstatementNode2);
        }
	nodeList.add(pnodanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new19() /* reduce AIfelseNoDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNoDanglingStatement pnodanglingstatementNode1;
        {
            // Block
        TKwIf tkwifNode2;
        TLparen tlparenNode3;
        PAssignment passignmentNode4;
        TRparen trparenNode5;
        PNoDanglingStatement pnodanglingstatementNode6;
        TKwElse tkwelseNode7;
        PNoDanglingStatement pnodanglingstatementNode8;
        tkwifNode2 = (TKwIf)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        passignmentNode4 = (PAssignment)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pnodanglingstatementNode6 = (PNoDanglingStatement)nodeArrayList5.get(0);
        tkwelseNode7 = (TKwElse)nodeArrayList6.get(0);
        pnodanglingstatementNode8 = (PNoDanglingStatement)nodeArrayList7.get(0);

        pnodanglingstatementNode1 = new AIfelseNoDanglingStatement(tkwifNode2, tlparenNode3, passignmentNode4, trparenNode5, pnodanglingstatementNode6, tkwelseNode7, pnodanglingstatementNode8);
        }
	nodeList.add(pnodanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new20() /* reduce AReturnNoDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNoDanglingStatement pnodanglingstatementNode1;
        {
            // Block
        PReturnstatement preturnstatementNode2;
        TSemicolon tsemicolonNode3;
        preturnstatementNode2 = (PReturnstatement)nodeArrayList1.get(0);
        tsemicolonNode3 = (TSemicolon)nodeArrayList2.get(0);

        pnodanglingstatementNode1 = new AReturnNoDanglingStatement(preturnstatementNode2, tsemicolonNode3);
        }
	nodeList.add(pnodanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new21() /* reduce ADowhileNoDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNoDanglingStatement pnodanglingstatementNode1;
        {
            // Block
        PDowhilestatement pdowhilestatementNode2;
        TSemicolon tsemicolonNode3;
        pdowhilestatementNode2 = (PDowhilestatement)nodeArrayList1.get(0);
        tsemicolonNode3 = (TSemicolon)nodeArrayList2.get(0);

        pnodanglingstatementNode1 = new ADowhileNoDanglingStatement(pdowhilestatementNode2, tsemicolonNode3);
        }
	nodeList.add(pnodanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new22() /* reduce APrintfNoDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNoDanglingStatement pnodanglingstatementNode1;
        {
            // Block
        PPrintf pprintfNode2;
        TSemicolon tsemicolonNode3;
        pprintfNode2 = (PPrintf)nodeArrayList1.get(0);
        tsemicolonNode3 = (TSemicolon)nodeArrayList2.get(0);

        pnodanglingstatementNode1 = new APrintfNoDanglingStatement(pprintfNode2, tsemicolonNode3);
        }
	nodeList.add(pnodanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new23() /* reduce ADeclassNoDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNoDanglingStatement pnodanglingstatementNode1;
        {
            // Block
        PDeclassignment pdeclassignmentNode2;
        TSemicolon tsemicolonNode3;
        pdeclassignmentNode2 = (PDeclassignment)nodeArrayList1.get(0);
        tsemicolonNode3 = (TSemicolon)nodeArrayList2.get(0);

        pnodanglingstatementNode1 = new ADeclassNoDanglingStatement(pdeclassignmentNode2, tsemicolonNode3);
        }
	nodeList.add(pnodanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new24() /* reduce AStatassNoDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNoDanglingStatement pnodanglingstatementNode1;
        {
            // Block
        PStatassignment pstatassignmentNode2;
        TSemicolon tsemicolonNode3;
        pstatassignmentNode2 = (PStatassignment)nodeArrayList1.get(0);
        tsemicolonNode3 = (TSemicolon)nodeArrayList2.get(0);

        pnodanglingstatementNode1 = new AStatassNoDanglingStatement(pstatassignmentNode2, tsemicolonNode3);
        }
	nodeList.add(pnodanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new25() /* reduce AFunccallNoDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNoDanglingStatement pnodanglingstatementNode1;
        {
            // Block
        PFunctioncall pfunctioncallNode2;
        TSemicolon tsemicolonNode3;
        pfunctioncallNode2 = (PFunctioncall)nodeArrayList1.get(0);
        tsemicolonNode3 = (TSemicolon)nodeArrayList2.get(0);

        pnodanglingstatementNode1 = new AFunccallNoDanglingStatement(pfunctioncallNode2, tsemicolonNode3);
        }
	nodeList.add(pnodanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new26() /* reduce AIfDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDanglingStatement pdanglingstatementNode1;
        {
            // Block
        TKwIf tkwifNode2;
        TLparen tlparenNode3;
        PAssignment passignmentNode4;
        TRparen trparenNode5;
        PStatement pstatementNode6;
        tkwifNode2 = (TKwIf)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        passignmentNode4 = (PAssignment)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pstatementNode6 = (PStatement)nodeArrayList5.get(0);

        pdanglingstatementNode1 = new AIfDanglingStatement(tkwifNode2, tlparenNode3, passignmentNode4, trparenNode5, pstatementNode6);
        }
	nodeList.add(pdanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new27() /* reduce AIfelseDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDanglingStatement pdanglingstatementNode1;
        {
            // Block
        TKwIf tkwifNode2;
        TLparen tlparenNode3;
        PAssignment passignmentNode4;
        TRparen trparenNode5;
        PNoDanglingStatement pnodanglingstatementNode6;
        TKwElse tkwelseNode7;
        PDanglingStatement pdanglingstatementNode8;
        tkwifNode2 = (TKwIf)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        passignmentNode4 = (PAssignment)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pnodanglingstatementNode6 = (PNoDanglingStatement)nodeArrayList5.get(0);
        tkwelseNode7 = (TKwElse)nodeArrayList6.get(0);
        pdanglingstatementNode8 = (PDanglingStatement)nodeArrayList7.get(0);

        pdanglingstatementNode1 = new AIfelseDanglingStatement(tkwifNode2, tlparenNode3, passignmentNode4, trparenNode5, pnodanglingstatementNode6, tkwelseNode7, pdanglingstatementNode8);
        }
	nodeList.add(pdanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new28() /* reduce AForDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDanglingStatement pdanglingstatementNode1;
        {
            // Block
        PForstatement pforstatementNode2;
        pforstatementNode2 = (PForstatement)nodeArrayList1.get(0);

        pdanglingstatementNode1 = new AForDanglingStatement(pforstatementNode2);
        }
	nodeList.add(pdanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new29() /* reduce AWhileDanglingStatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDanglingStatement pdanglingstatementNode1;
        {
            // Block
        PWhilestatement pwhilestatementNode2;
        pwhilestatementNode2 = (PWhilestatement)nodeArrayList1.get(0);

        pdanglingstatementNode1 = new AWhileDanglingStatement(pwhilestatementNode2);
        }
	nodeList.add(pdanglingstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new30() /* reduce AStatassForstatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList9 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList8 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PForstatement pforstatementNode1;
        {
            // Block
        TKwFor tkwforNode2;
        TLparen tlparenNode3;
        PStatassignment pstatassignmentNode4;
        TSemicolon tsemicolonNode5;
        PExpr pexprNode6;
        TSemicolon tsemicolonNode7;
        PStatassignment pstatassignmentNode8;
        TRparen trparenNode9;
        PStatement pstatementNode10;
        tkwforNode2 = (TKwFor)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pstatassignmentNode4 = (PStatassignment)nodeArrayList3.get(0);
        tsemicolonNode5 = (TSemicolon)nodeArrayList4.get(0);
        pexprNode6 = (PExpr)nodeArrayList5.get(0);
        tsemicolonNode7 = (TSemicolon)nodeArrayList6.get(0);
        pstatassignmentNode8 = (PStatassignment)nodeArrayList7.get(0);
        trparenNode9 = (TRparen)nodeArrayList8.get(0);
        pstatementNode10 = (PStatement)nodeArrayList9.get(0);

        pforstatementNode1 = new AStatassForstatement(tkwforNode2, tlparenNode3, pstatassignmentNode4, tsemicolonNode5, pexprNode6, tsemicolonNode7, pstatassignmentNode8, trparenNode9, pstatementNode10);
        }
	nodeList.add(pforstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new31() /* reduce ADeclassForstatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList9 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList8 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PForstatement pforstatementNode1;
        {
            // Block
        TKwFor tkwforNode2;
        TLparen tlparenNode3;
        PDeclassignment pdeclassignmentNode4;
        TSemicolon tsemicolonNode5;
        PExpr pexprNode6;
        TSemicolon tsemicolonNode7;
        PStatassignment pstatassignmentNode8;
        TRparen trparenNode9;
        PStatement pstatementNode10;
        tkwforNode2 = (TKwFor)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pdeclassignmentNode4 = (PDeclassignment)nodeArrayList3.get(0);
        tsemicolonNode5 = (TSemicolon)nodeArrayList4.get(0);
        pexprNode6 = (PExpr)nodeArrayList5.get(0);
        tsemicolonNode7 = (TSemicolon)nodeArrayList6.get(0);
        pstatassignmentNode8 = (PStatassignment)nodeArrayList7.get(0);
        trparenNode9 = (TRparen)nodeArrayList8.get(0);
        pstatementNode10 = (PStatement)nodeArrayList9.get(0);

        pforstatementNode1 = new ADeclassForstatement(tkwforNode2, tlparenNode3, pdeclassignmentNode4, tsemicolonNode5, pexprNode6, tsemicolonNode7, pstatassignmentNode8, trparenNode9, pstatementNode10);
        }
	nodeList.add(pforstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new32() /* reduce ADowhilestatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDowhilestatement pdowhilestatementNode1;
        {
            // Block
        TKwDo tkwdoNode2;
        PStatement pstatementNode3;
        TKwWhile tkwwhileNode4;
        TLparen tlparenNode5;
        PAssignment passignmentNode6;
        TRparen trparenNode7;
        tkwdoNode2 = (TKwDo)nodeArrayList1.get(0);
        pstatementNode3 = (PStatement)nodeArrayList2.get(0);
        tkwwhileNode4 = (TKwWhile)nodeArrayList3.get(0);
        tlparenNode5 = (TLparen)nodeArrayList4.get(0);
        passignmentNode6 = (PAssignment)nodeArrayList5.get(0);
        trparenNode7 = (TRparen)nodeArrayList6.get(0);

        pdowhilestatementNode1 = new ADowhilestatement(tkwdoNode2, pstatementNode3, tkwwhileNode4, tlparenNode5, passignmentNode6, trparenNode7);
        }
	nodeList.add(pdowhilestatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new33() /* reduce AWhilestatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PWhilestatement pwhilestatementNode1;
        {
            // Block
        TKwWhile tkwwhileNode2;
        TLparen tlparenNode3;
        PAssignment passignmentNode4;
        TRparen trparenNode5;
        PStatement pstatementNode6;
        tkwwhileNode2 = (TKwWhile)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        passignmentNode4 = (PAssignment)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pstatementNode6 = (PStatement)nodeArrayList5.get(0);

        pwhilestatementNode1 = new AWhilestatement(tkwwhileNode2, tlparenNode3, passignmentNode4, trparenNode5, pstatementNode6);
        }
	nodeList.add(pwhilestatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new34() /* reduce AAreturnstatement1Returnstatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PReturnstatement preturnstatementNode1;
        {
            // Block
        TKwReturn tkwreturnNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        tkwreturnNode2 = (TKwReturn)nodeArrayList1.get(0);

        preturnstatementNode1 = new AReturnstatement(tkwreturnNode2, null);
        }
	nodeList.add(preturnstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new35() /* reduce AAreturnstatement2Returnstatement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PReturnstatement preturnstatementNode1;
        {
            // Block
        TKwReturn tkwreturnNode2;
        PAssignment passignmentNode3;
        tkwreturnNode2 = (TKwReturn)nodeArrayList1.get(0);
        passignmentNode3 = (PAssignment)nodeArrayList2.get(0);

        preturnstatementNode1 = new AReturnstatement(tkwreturnNode2, passignmentNode3);
        }
	nodeList.add(preturnstatementNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new36() /* reduce APrintf */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPrintf pprintfNode1;
        {
            // Block
        TKwPrintf tkwprintfNode2;
        TLparen tlparenNode3;
        PAssignment passignmentNode4;
        TRparen trparenNode5;
        tkwprintfNode2 = (TKwPrintf)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        passignmentNode4 = (PAssignment)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);

        pprintfNode1 = new APrintf(tkwprintfNode2, tlparenNode3, passignmentNode4, trparenNode5);
        }
	nodeList.add(pprintfNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new37() /* reduce ANoassignDeclassignment */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDeclassignment pdeclassignmentNode1;
        {
            // Block
        PType ptypeNode2;
        PId pidNode3;
        ptypeNode2 = (PType)nodeArrayList1.get(0);
        pidNode3 = (PId)nodeArrayList2.get(0);

        pdeclassignmentNode1 = new ANoassignDeclassignment(ptypeNode2, pidNode3);
        }
	nodeList.add(pdeclassignmentNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new38() /* reduce AAssignDeclassignment */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDeclassignment pdeclassignmentNode1;
        {
            // Block
        PType ptypeNode2;
        PId pidNode3;
        TAssign tassignNode4;
        PAssignment passignmentNode5;
        ptypeNode2 = (PType)nodeArrayList1.get(0);
        pidNode3 = (PId)nodeArrayList2.get(0);
        tassignNode4 = (TAssign)nodeArrayList3.get(0);
        passignmentNode5 = (PAssignment)nodeArrayList4.get(0);

        pdeclassignmentNode1 = new AAssignDeclassignment(ptypeNode2, pidNode3, tassignNode4, passignmentNode5);
        }
	nodeList.add(pdeclassignmentNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new39() /* reduce ABooleanType */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PType ptypeNode1;
        {
            // Block
        TKwBoolean tkwbooleanNode2;
        tkwbooleanNode2 = (TKwBoolean)nodeArrayList1.get(0);

        ptypeNode1 = new ABooleanType(tkwbooleanNode2);
        }
	nodeList.add(ptypeNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new40() /* reduce AFloatType */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PType ptypeNode1;
        {
            // Block
        TKwFloat tkwfloatNode2;
        tkwfloatNode2 = (TKwFloat)nodeArrayList1.get(0);

        ptypeNode1 = new AFloatType(tkwfloatNode2);
        }
	nodeList.add(ptypeNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new41() /* reduce AIntType */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PType ptypeNode1;
        {
            // Block
        TKwInt tkwintNode2;
        tkwintNode2 = (TKwInt)nodeArrayList1.get(0);

        ptypeNode1 = new AIntType(tkwintNode2);
        }
	nodeList.add(ptypeNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new42() /* reduce AVoidType */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PType ptypeNode1;
        {
            // Block
        TKwVoid tkwvoidNode2;
        tkwvoidNode2 = (TKwVoid)nodeArrayList1.get(0);

        ptypeNode1 = new AVoidType(tkwvoidNode2);
        }
	nodeList.add(ptypeNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new43() /* reduce AStatassignment */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PStatassignment pstatassignmentNode1;
        {
            // Block
        PId pidNode2;
        TAssign tassignNode3;
        PAssignment passignmentNode4;
        pidNode2 = (PId)nodeArrayList1.get(0);
        tassignNode3 = (TAssign)nodeArrayList2.get(0);
        passignmentNode4 = (PAssignment)nodeArrayList3.get(0);

        pstatassignmentNode1 = new AStatassignment(pidNode2, tassignNode3, passignmentNode4);
        }
	nodeList.add(pstatassignmentNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new44() /* reduce AAssAssignment */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAssignment passignmentNode1;
        {
            // Block
        PId pidNode2;
        TAssign tassignNode3;
        PAssignment passignmentNode4;
        pidNode2 = (PId)nodeArrayList1.get(0);
        tassignNode3 = (TAssign)nodeArrayList2.get(0);
        passignmentNode4 = (PAssignment)nodeArrayList3.get(0);

        passignmentNode1 = new AAssAssignment(pidNode2, tassignNode3, passignmentNode4);
        }
	nodeList.add(passignmentNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new45() /* reduce AExprAssignment */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAssignment passignmentNode1;
        {
            // Block
        PExpr pexprNode2;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);

        passignmentNode1 = new AExprAssignment(pexprNode2);
        }
	nodeList.add(passignmentNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new46() /* reduce ATermExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PTerm ptermNode2;
        ptermNode2 = (PTerm)nodeArrayList1.get(0);

        pexprNode1 = new ATermExpr(ptermNode2);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new47() /* reduce AMinTermExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        TMinus tminusNode2;
        PTerm ptermNode3;
        tminusNode2 = (TMinus)nodeArrayList1.get(0);
        ptermNode3 = (PTerm)nodeArrayList2.get(0);

        pexprNode1 = new AMinTermExpr(tminusNode2, ptermNode3);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new48() /* reduce AEqExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        TEq teqNode3;
        PTerm ptermNode4;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        teqNode3 = (TEq)nodeArrayList2.get(0);
        ptermNode4 = (PTerm)nodeArrayList3.get(0);

        pexprNode1 = new AEqExpr(pexprNode2, teqNode3, ptermNode4);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new49() /* reduce ANeqExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        TNeq tneqNode3;
        PTerm ptermNode4;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        tneqNode3 = (TNeq)nodeArrayList2.get(0);
        ptermNode4 = (PTerm)nodeArrayList3.get(0);

        pexprNode1 = new ANeqExpr(pexprNode2, tneqNode3, ptermNode4);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new50() /* reduce ALssExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        TLss tlssNode3;
        PTerm ptermNode4;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        tlssNode3 = (TLss)nodeArrayList2.get(0);
        ptermNode4 = (PTerm)nodeArrayList3.get(0);

        pexprNode1 = new ALssExpr(pexprNode2, tlssNode3, ptermNode4);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new51() /* reduce AGrtExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        TGrt tgrtNode3;
        PTerm ptermNode4;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        tgrtNode3 = (TGrt)nodeArrayList2.get(0);
        ptermNode4 = (PTerm)nodeArrayList3.get(0);

        pexprNode1 = new AGrtExpr(pexprNode2, tgrtNode3, ptermNode4);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new52() /* reduce ALeqExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        TLeq tleqNode3;
        PTerm ptermNode4;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        tleqNode3 = (TLeq)nodeArrayList2.get(0);
        ptermNode4 = (PTerm)nodeArrayList3.get(0);

        pexprNode1 = new ALeqExpr(pexprNode2, tleqNode3, ptermNode4);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new53() /* reduce AGeqExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        TGeq tgeqNode3;
        PTerm ptermNode4;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        tgeqNode3 = (TGeq)nodeArrayList2.get(0);
        ptermNode4 = (PTerm)nodeArrayList3.get(0);

        pexprNode1 = new AGeqExpr(pexprNode2, tgeqNode3, ptermNode4);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new54() /* reduce APlusExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        TPlus tplusNode3;
        PTerm ptermNode4;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        tplusNode3 = (TPlus)nodeArrayList2.get(0);
        ptermNode4 = (PTerm)nodeArrayList3.get(0);

        pexprNode1 = new APlusExpr(pexprNode2, tplusNode3, ptermNode4);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new55() /* reduce AMinusExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        TMinus tminusNode3;
        PTerm ptermNode4;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        tminusNode3 = (TMinus)nodeArrayList2.get(0);
        ptermNode4 = (PTerm)nodeArrayList3.get(0);

        pexprNode1 = new AMinusExpr(pexprNode2, tminusNode3, ptermNode4);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new56() /* reduce AOrExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        PExpr pexprNode2;
        TOr torNode3;
        PTerm ptermNode4;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);
        torNode3 = (TOr)nodeArrayList2.get(0);
        ptermNode4 = (PTerm)nodeArrayList3.get(0);

        pexprNode1 = new AOrExpr(pexprNode2, torNode3, ptermNode4);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new57() /* reduce AFactorTerm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTerm ptermNode1;
        {
            // Block
        PFactor pfactorNode2;
        pfactorNode2 = (PFactor)nodeArrayList1.get(0);

        ptermNode1 = new AFactorTerm(pfactorNode2);
        }
	nodeList.add(ptermNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new58() /* reduce AMulTerm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTerm ptermNode1;
        {
            // Block
        PTerm ptermNode2;
        TAsteriks tasteriksNode3;
        PFactor pfactorNode4;
        ptermNode2 = (PTerm)nodeArrayList1.get(0);
        tasteriksNode3 = (TAsteriks)nodeArrayList2.get(0);
        pfactorNode4 = (PFactor)nodeArrayList3.get(0);

        ptermNode1 = new AMulTerm(ptermNode2, tasteriksNode3, pfactorNode4);
        }
	nodeList.add(ptermNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new59() /* reduce ADivTerm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTerm ptermNode1;
        {
            // Block
        PTerm ptermNode2;
        TSlash tslashNode3;
        PFactor pfactorNode4;
        ptermNode2 = (PTerm)nodeArrayList1.get(0);
        tslashNode3 = (TSlash)nodeArrayList2.get(0);
        pfactorNode4 = (PFactor)nodeArrayList3.get(0);

        ptermNode1 = new ADivTerm(ptermNode2, tslashNode3, pfactorNode4);
        }
	nodeList.add(ptermNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new60() /* reduce AAndTerm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTerm ptermNode1;
        {
            // Block
        PTerm ptermNode2;
        TAnd tandNode3;
        PFactor pfactorNode4;
        ptermNode2 = (PTerm)nodeArrayList1.get(0);
        tandNode3 = (TAnd)nodeArrayList2.get(0);
        pfactorNode4 = (PFactor)nodeArrayList3.get(0);

        ptermNode1 = new AAndTerm(ptermNode2, tandNode3, pfactorNode4);
        }
	nodeList.add(ptermNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new61() /* reduce AIntFactor */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFactor pfactorNode1;
        {
            // Block
        TConstInt tconstintNode2;
        tconstintNode2 = (TConstInt)nodeArrayList1.get(0);

        pfactorNode1 = new AIntFactor(tconstintNode2);
        }
	nodeList.add(pfactorNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new62() /* reduce AFloatFactor */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFactor pfactorNode1;
        {
            // Block
        TConstFloat tconstfloatNode2;
        tconstfloatNode2 = (TConstFloat)nodeArrayList1.get(0);

        pfactorNode1 = new AFloatFactor(tconstfloatNode2);
        }
	nodeList.add(pfactorNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new63() /* reduce ABooleanFactor */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFactor pfactorNode1;
        {
            // Block
        TConstBoolean tconstbooleanNode2;
        tconstbooleanNode2 = (TConstBoolean)nodeArrayList1.get(0);

        pfactorNode1 = new ABooleanFactor(tconstbooleanNode2);
        }
	nodeList.add(pfactorNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new64() /* reduce AFunccallFactor */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFactor pfactorNode1;
        {
            // Block
        PFunctioncall pfunctioncallNode2;
        pfunctioncallNode2 = (PFunctioncall)nodeArrayList1.get(0);

        pfactorNode1 = new AFunccallFactor(pfunctioncallNode2);
        }
	nodeList.add(pfactorNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new65() /* reduce AIdFactor */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFactor pfactorNode1;
        {
            // Block
        PId pidNode2;
        pidNode2 = (PId)nodeArrayList1.get(0);

        pfactorNode1 = new AIdFactor(pidNode2);
        }
	nodeList.add(pfactorNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new66() /* reduce AAssFactor */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFactor pfactorNode1;
        {
            // Block
        TLparen tlparenNode2;
        PAssignment passignmentNode3;
        TRparen trparenNode4;
        tlparenNode2 = (TLparen)nodeArrayList1.get(0);
        passignmentNode3 = (PAssignment)nodeArrayList2.get(0);
        trparenNode4 = (TRparen)nodeArrayList3.get(0);

        pfactorNode1 = new AAssFactor(tlparenNode2, passignmentNode3, trparenNode4);
        }
	nodeList.add(pfactorNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new67() /* reduce AId */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PId pidNode1;
        {
            // Block
        TIdent tidentNode2;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);

        pidNode1 = new AId(tidentNode2);
        }
	nodeList.add(pidNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new68() /* reduce ATerminal$Program1 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PProgram1 pprogram1Node1;
        pprogram1Node1 = (PProgram1)nodeArrayList1.get(0);
	if(pprogram1Node1 != null)
	{
	  listNode2.add(pprogram1Node1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new69() /* reduce ANonTerminal$Program1 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PProgram1 pprogram1Node2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pprogram1Node2 = (PProgram1)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pprogram1Node2 != null)
	{
	  listNode3.add(pprogram1Node2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new70() /* reduce ATerminal$Paramlisttemp */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PParamlisttemp pparamlisttempNode1;
        pparamlisttempNode1 = (PParamlisttemp)nodeArrayList1.get(0);
	if(pparamlisttempNode1 != null)
	{
	  listNode2.add(pparamlisttempNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new71() /* reduce ANonTerminal$Paramlisttemp */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PParamlisttemp pparamlisttempNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pparamlisttempNode2 = (PParamlisttemp)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pparamlisttempNode2 != null)
	{
	  listNode3.add(pparamlisttempNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new72() /* reduce ATerminal$Funcparams */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PFuncparams pfuncparamsNode1;
        pfuncparamsNode1 = (PFuncparams)nodeArrayList1.get(0);
	if(pfuncparamsNode1 != null)
	{
	  listNode2.add(pfuncparamsNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new73() /* reduce ANonTerminal$Funcparams */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PFuncparams pfuncparamsNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pfuncparamsNode2 = (PFuncparams)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pfuncparamsNode2 != null)
	{
	  listNode3.add(pfuncparamsNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new74() /* reduce ATerminal$Statement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PStatement pstatementNode1;
        pstatementNode1 = (PStatement)nodeArrayList1.get(0);
	if(pstatementNode1 != null)
	{
	  listNode2.add(pstatementNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new75() /* reduce ANonTerminal$Statement */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PStatement pstatementNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pstatementNode2 = (PStatement)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pstatementNode2 != null)
	{
	  listNode3.add(pstatementNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    private static int[][][] actionTable;
/*      {
			{{-1, REDUCE, 0}, {0, SHIFT, 1}, {3, SHIFT, 2}, {6, SHIFT, 3}, {9, SHIFT, 4}, },
			{{-1, REDUCE, 39}, },
			{{-1, REDUCE, 40}, },
			{{-1, REDUCE, 41}, },
			{{-1, REDUCE, 42}, },
			{{-1, ERROR, 5}, {34, ACCEPT, -1}, },
			{{-1, REDUCE, 68}, },
			{{-1, REDUCE, 3}, },
			{{-1, ERROR, 8}, {25, SHIFT, 11}, },
			{{-1, ERROR, 9}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 1}, {0, SHIFT, 1}, {3, SHIFT, 2}, {6, SHIFT, 3}, {9, SHIFT, 4}, },
			{{-1, REDUCE, 2}, },
			{{-1, REDUCE, 67}, },
			{{-1, REDUCE, 37}, {15, SHIFT, 15}, {26, SHIFT, 16}, },
			{{-1, REDUCE, 69}, },
			{{-1, ERROR, 15}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 16}, {0, SHIFT, 1}, {3, SHIFT, 2}, {6, SHIFT, 3}, {9, SHIFT, 4}, {27, SHIFT, 28}, },
			{{-1, ERROR, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 18}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 61}, },
			{{-1, REDUCE, 62}, },
			{{-1, REDUCE, 63}, },
			{{-1, REDUCE, 64}, },
			{{-1, REDUCE, 38}, },
			{{-1, REDUCE, 45}, {11, SHIFT, 34}, {12, SHIFT, 35}, {16, SHIFT, 36}, {17, SHIFT, 37}, {18, SHIFT, 38}, {19, SHIFT, 39}, {20, SHIFT, 40}, {21, SHIFT, 41}, {23, SHIFT, 42}, },
			{{-1, REDUCE, 46}, {13, SHIFT, 43}, {14, SHIFT, 44}, {22, SHIFT, 45}, },
			{{-1, REDUCE, 57}, },
			{{-1, REDUCE, 65}, {15, SHIFT, 46}, {26, SHIFT, 47}, },
			{{-1, ERROR, 28}, {28, SHIFT, 48}, },
			{{-1, ERROR, 29}, {27, SHIFT, 50}, },
			{{-1, ERROR, 30}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 47}, {13, SHIFT, 43}, {14, SHIFT, 44}, {22, SHIFT, 45}, },
			{{-1, REDUCE, 65}, {26, SHIFT, 47}, },
			{{-1, ERROR, 33}, {27, SHIFT, 52}, },
			{{-1, ERROR, 34}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 35}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 36}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 37}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 38}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 39}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 40}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 41}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 42}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 43}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 44}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 45}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 46}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 47}, {12, SHIFT, 17}, {26, SHIFT, 18}, {27, SHIFT, 66}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 48}, {0, SHIFT, 1}, {1, SHIFT, 68}, {3, SHIFT, 2}, {4, SHIFT, 69}, {5, SHIFT, 70}, {6, SHIFT, 3}, {7, SHIFT, 71}, {8, SHIFT, 72}, {9, SHIFT, 4}, {10, SHIFT, 73}, {28, SHIFT, 48}, {29, SHIFT, 74}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 4}, },
			{{-1, ERROR, 50}, {28, SHIFT, 48}, },
			{{-1, REDUCE, 6}, {24, SHIFT, 92}, },
			{{-1, REDUCE, 66}, },
			{{-1, REDUCE, 54}, {13, SHIFT, 43}, {14, SHIFT, 44}, {22, SHIFT, 45}, },
			{{-1, REDUCE, 55}, {13, SHIFT, 43}, {14, SHIFT, 44}, {22, SHIFT, 45}, },
			{{-1, REDUCE, 48}, {13, SHIFT, 43}, {14, SHIFT, 44}, {22, SHIFT, 45}, },
			{{-1, REDUCE, 49}, {13, SHIFT, 43}, {14, SHIFT, 44}, {22, SHIFT, 45}, },
			{{-1, REDUCE, 50}, {13, SHIFT, 43}, {14, SHIFT, 44}, {22, SHIFT, 45}, },
			{{-1, REDUCE, 51}, {13, SHIFT, 43}, {14, SHIFT, 44}, {22, SHIFT, 45}, },
			{{-1, REDUCE, 52}, {13, SHIFT, 43}, {14, SHIFT, 44}, {22, SHIFT, 45}, },
			{{-1, REDUCE, 53}, {13, SHIFT, 43}, {14, SHIFT, 44}, {22, SHIFT, 45}, },
			{{-1, REDUCE, 56}, {13, SHIFT, 43}, {14, SHIFT, 44}, {22, SHIFT, 45}, },
			{{-1, REDUCE, 58}, },
			{{-1, REDUCE, 59}, },
			{{-1, REDUCE, 60}, },
			{{-1, REDUCE, 44}, },
			{{-1, REDUCE, 9}, },
			{{-1, ERROR, 67}, {24, SHIFT, 95}, {27, SHIFT, 96}, },
			{{-1, ERROR, 68}, {0, SHIFT, 1}, {1, SHIFT, 68}, {3, SHIFT, 2}, {4, SHIFT, 69}, {5, SHIFT, 70}, {6, SHIFT, 3}, {7, SHIFT, 71}, {8, SHIFT, 72}, {9, SHIFT, 4}, {10, SHIFT, 73}, {28, SHIFT, 48}, {33, SHIFT, 12}, },
			{{-1, ERROR, 69}, {26, SHIFT, 100}, },
			{{-1, ERROR, 70}, {26, SHIFT, 101}, },
			{{-1, ERROR, 71}, {26, SHIFT, 102}, },
			{{-1, REDUCE, 34}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 73}, {26, SHIFT, 104}, },
			{{-1, REDUCE, 13}, },
			{{-1, ERROR, 75}, {25, SHIFT, 105}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 77}, {29, SHIFT, 106}, },
			{{-1, REDUCE, 74}, },
			{{-1, REDUCE, 16}, },
			{{-1, REDUCE, 17}, },
			{{-1, REDUCE, 28}, },
			{{-1, ERROR, 82}, {25, SHIFT, 107}, },
			{{-1, REDUCE, 29}, },
			{{-1, ERROR, 84}, {25, SHIFT, 108}, },
			{{-1, ERROR, 85}, {25, SHIFT, 109}, },
			{{-1, ERROR, 86}, {25, SHIFT, 110}, },
			{{-1, ERROR, 87}, {33, SHIFT, 12}, },
			{{-1, ERROR, 88}, {25, SHIFT, 112}, },
			{{-1, ERROR, 89}, {15, SHIFT, 113}, {26, SHIFT, 47}, },
			{{-1, REDUCE, 15}, {0, SHIFT, 1}, {1, SHIFT, 68}, {3, SHIFT, 2}, {4, SHIFT, 69}, {5, SHIFT, 70}, {6, SHIFT, 3}, {7, SHIFT, 71}, {8, SHIFT, 72}, {9, SHIFT, 4}, {10, SHIFT, 73}, {28, SHIFT, 48}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 92}, {0, SHIFT, 1}, {3, SHIFT, 2}, {6, SHIFT, 3}, {9, SHIFT, 4}, },
			{{-1, REDUCE, 70}, },
			{{-1, REDUCE, 7}, {24, SHIFT, 92}, },
			{{-1, ERROR, 95}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 10}, },
			{{-1, REDUCE, 72}, },
			{{-1, ERROR, 98}, {24, SHIFT, 95}, {27, SHIFT, 118}, },
			{{-1, ERROR, 99}, {10, SHIFT, 120}, },
			{{-1, ERROR, 100}, {0, SHIFT, 1}, {3, SHIFT, 2}, {6, SHIFT, 3}, {9, SHIFT, 4}, {33, SHIFT, 12}, },
			{{-1, ERROR, 101}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 102}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 35}, },
			{{-1, ERROR, 104}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 25}, },
			{{-1, REDUCE, 14}, },
			{{-1, REDUCE, 21}, },
			{{-1, REDUCE, 20}, },
			{{-1, REDUCE, 22}, },
			{{-1, REDUCE, 23}, },
			{{-1, REDUCE, 37}, {15, SHIFT, 15}, },
			{{-1, REDUCE, 24}, },
			{{-1, ERROR, 113}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 75}, },
			{{-1, ERROR, 115}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 71}, },
			{{-1, REDUCE, 12}, },
			{{-1, REDUCE, 11}, },
			{{-1, REDUCE, 73}, },
			{{-1, ERROR, 120}, {26, SHIFT, 129}, },
			{{-1, ERROR, 121}, {25, SHIFT, 130}, },
			{{-1, ERROR, 122}, {25, SHIFT, 131}, },
			{{-1, ERROR, 123}, {15, SHIFT, 113}, },
			{{-1, ERROR, 124}, {27, SHIFT, 132}, },
			{{-1, ERROR, 125}, {27, SHIFT, 133}, },
			{{-1, ERROR, 126}, {27, SHIFT, 134}, },
			{{-1, REDUCE, 43}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 129}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 130}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 131}, {12, SHIFT, 17}, {26, SHIFT, 18}, {30, SHIFT, 19}, {31, SHIFT, 20}, {32, SHIFT, 21}, {33, SHIFT, 12}, },
			{{-1, ERROR, 132}, {0, SHIFT, 1}, {1, SHIFT, 68}, {3, SHIFT, 2}, {4, SHIFT, 69}, {5, SHIFT, 70}, {6, SHIFT, 3}, {7, SHIFT, 71}, {8, SHIFT, 72}, {9, SHIFT, 4}, {10, SHIFT, 73}, {28, SHIFT, 48}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 36}, },
			{{-1, ERROR, 134}, {0, SHIFT, 1}, {1, SHIFT, 68}, {3, SHIFT, 2}, {4, SHIFT, 69}, {5, SHIFT, 70}, {6, SHIFT, 3}, {7, SHIFT, 71}, {8, SHIFT, 72}, {9, SHIFT, 4}, {10, SHIFT, 73}, {28, SHIFT, 48}, {33, SHIFT, 12}, },
			{{-1, ERROR, 135}, {27, SHIFT, 141}, },
			{{-1, ERROR, 136}, {11, SHIFT, 34}, {12, SHIFT, 35}, {16, SHIFT, 36}, {17, SHIFT, 37}, {18, SHIFT, 38}, {19, SHIFT, 39}, {20, SHIFT, 40}, {21, SHIFT, 41}, {23, SHIFT, 42}, {25, SHIFT, 142}, },
			{{-1, ERROR, 137}, {11, SHIFT, 34}, {12, SHIFT, 35}, {16, SHIFT, 36}, {17, SHIFT, 37}, {18, SHIFT, 38}, {19, SHIFT, 39}, {20, SHIFT, 40}, {21, SHIFT, 41}, {23, SHIFT, 42}, {25, SHIFT, 143}, },
			{{-1, REDUCE, 26}, },
			{{-1, REDUCE, 16}, {2, SHIFT, 144}, },
			{{-1, REDUCE, 33}, },
			{{-1, REDUCE, 32}, },
			{{-1, ERROR, 142}, {33, SHIFT, 12}, },
			{{-1, ERROR, 143}, {33, SHIFT, 12}, },
			{{-1, ERROR, 144}, {0, SHIFT, 1}, {1, SHIFT, 68}, {3, SHIFT, 2}, {4, SHIFT, 69}, {5, SHIFT, 70}, {6, SHIFT, 3}, {7, SHIFT, 71}, {8, SHIFT, 72}, {9, SHIFT, 4}, {10, SHIFT, 73}, {28, SHIFT, 48}, {33, SHIFT, 12}, },
			{{-1, ERROR, 145}, {27, SHIFT, 149}, },
			{{-1, ERROR, 146}, {27, SHIFT, 150}, },
			{{-1, REDUCE, 19}, },
			{{-1, REDUCE, 27}, },
			{{-1, ERROR, 149}, {0, SHIFT, 1}, {1, SHIFT, 68}, {3, SHIFT, 2}, {4, SHIFT, 69}, {5, SHIFT, 70}, {6, SHIFT, 3}, {7, SHIFT, 71}, {8, SHIFT, 72}, {9, SHIFT, 4}, {10, SHIFT, 73}, {28, SHIFT, 48}, {33, SHIFT, 12}, },
			{{-1, ERROR, 150}, {0, SHIFT, 1}, {1, SHIFT, 68}, {3, SHIFT, 2}, {4, SHIFT, 69}, {5, SHIFT, 70}, {6, SHIFT, 3}, {7, SHIFT, 71}, {8, SHIFT, 72}, {9, SHIFT, 4}, {10, SHIFT, 73}, {28, SHIFT, 48}, {33, SHIFT, 12}, },
			{{-1, REDUCE, 31}, },
			{{-1, REDUCE, 30}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 5}, },
			{{-1, 6}, {10, 14}, },
			{{-1, 7}, },
			{{-1, 29}, },
			{{-1, 93}, {94, 116}, },
			{{-1, 22}, {48, 75}, {68, 75}, {90, 75}, {132, 75}, {134, 75}, {144, 75}, {149, 75}, {150, 75}, },
			{{-1, 97}, {98, 119}, },
			{{-1, 76}, {28, 49}, {50, 91}, },
			{{-1, 77}, },
			{{-1, 78}, {68, 99}, {90, 114}, {132, 138}, {134, 140}, {149, 151}, {150, 152}, },
			{{-1, 79}, {132, 139}, {144, 147}, },
			{{-1, 80}, {144, 148}, },
			{{-1, 81}, },
			{{-1, 82}, },
			{{-1, 83}, },
			{{-1, 84}, },
			{{-1, 85}, },
			{{-1, 86}, {0, 8}, {10, 8}, {100, 121}, },
			{{-1, 87}, {0, 9}, {10, 9}, {16, 30}, {92, 115}, },
			{{-1, 88}, {100, 122}, {142, 145}, {143, 146}, },
			{{-1, 23}, {18, 33}, {46, 65}, {47, 67}, {72, 103}, {95, 117}, {101, 124}, {102, 125}, {104, 126}, {113, 127}, {129, 135}, },
			{{-1, 24}, {130, 136}, {131, 137}, },
			{{-1, 25}, {17, 31}, {34, 53}, {35, 54}, {36, 55}, {37, 56}, {38, 57}, {39, 58}, {40, 59}, {41, 60}, {42, 61}, },
			{{-1, 26}, {43, 62}, {44, 63}, {45, 64}, },
			{{-1, 32}, {9, 13}, {15, 27}, {18, 27}, {30, 51}, {46, 27}, {47, 27}, {48, 89}, {68, 89}, {72, 27}, {87, 111}, {90, 89}, {95, 27}, {100, 123}, {101, 27}, {102, 27}, {104, 27}, {113, 27}, {115, 128}, {129, 27}, {132, 89}, {134, 89}, {142, 123}, {143, 123}, {144, 89}, {149, 89}, {150, 89}, },
			{{-1, 10}, },
			{{-1, 94}, },
			{{-1, 98}, },
			{{-1, 90}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'bool', 'float', 'int', 'void', EOF",
			"expecting: ident",
			"expecting: EOF",
			"expecting: ';'",
			"expecting: '+', '-', '*', '/', '=', '==', '!=', '<', '>', '<=', '>=', '&&', '||', ',', ';', '(', ')'",
			"expecting: '=', ';', '('",
			"expecting: '-', '(', const int, const float, const boolean, ident",
			"expecting: 'bool', 'float', 'int', 'void', ')'",
			"expecting: '(', const int, const float, const boolean, ident",
			"expecting: '+', '-', '*', '/', '==', '!=', '<', '>', '<=', '>=', '&&', '||', ',', ';', ')'",
			"expecting: '+', '-', '==', '!=', '<', '>', '<=', '>=', '||', ',', ';', ')'",
			"expecting: '{'",
			"expecting: ')'",
			"expecting: '+', '-', '*', '/', '==', '!=', '<', '>', '<=', '>=', '&&', '||', ',', ';', '(', ')'",
			"expecting: '-', '(', ')', const int, const float, const boolean, ident",
			"expecting: 'bool', 'do', 'float', 'for', 'if', 'int', 'printf', 'return', 'void', 'while', '{', '}', ident",
			"expecting: ',', ')'",
			"expecting: ',', ';', ')'",
			"expecting: 'bool', 'do', 'float', 'for', 'if', 'int', 'printf', 'return', 'void', 'while', '{', ident",
			"expecting: '('",
			"expecting: '-', ';', '(', const int, const float, const boolean, ident",
			"expecting: 'bool', 'do', 'else', 'float', 'for', 'if', 'int', 'printf', 'return', 'void', 'while', '{', '}', ident, EOF",
			"expecting: 'bool', 'do', 'else', 'float', 'for', 'if', 'int', 'printf', 'return', 'void', 'while', '{', '}', ident",
			"expecting: '}'",
			"expecting: '=', '('",
			"expecting: 'bool', 'float', 'int', 'void'",
			"expecting: 'while'",
			"expecting: 'bool', 'float', 'int', 'void', ident",
			"expecting: '=', ';'",
			"expecting: '='",
			"expecting: ';', ')'",
			"expecting: '+', '-', '==', '!=', '<', '>', '<=', '>=', '||', ';'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 1, 1, 1, 2, 0, 0, 3, 1, 0, 0, 4, 5, 0, 6, 7, 8, 6, 9, 9, 9, 9, 3, 10, 9, 9, 4, 11, 12, 1, 9, 13, 12, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 6, 14, 15, 0, 11, 16, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 17, 9, 16, 18, 19, 19, 19, 20, 19, 21, 3, 22, 23, 15, 15, 15, 15, 3, 15, 3, 3, 3, 1, 3, 24, 15, 0, 25, 16, 16, 6, 9, 16, 16, 26, 27, 6, 6, 3, 6, 22, 21, 22, 22, 22, 22, 28, 22, 6, 15, 1, 16, 16, 9, 16, 19, 3, 3, 29, 12, 12, 12, 30, 16, 6, 6, 6, 18, 3, 18, 12, 31, 31, 15, 22, 15, 3, 1, 1, 18, 12, 12, 22, 15, 18, 18, 15, 15, 
        };*/

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Parser.class.getResourceAsStream("parser.dat")));

            // read actionTable
            int length = s.readInt();
            Parser.actionTable = new int[length][][];
            for(int i = 0; i < Parser.actionTable.length; i++)
            {
                length = s.readInt();
                Parser.actionTable[i] = new int[length][3];
                for(int j = 0; j < Parser.actionTable[i].length; j++)
                {
                for(int k = 0; k < 3; k++)
                {
                    Parser.actionTable[i][j][k] = s.readInt();
                }
                }
            }

            // read gotoTable
            length = s.readInt();
            gotoTable = new int[length][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][2];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                for(int k = 0; k < 2; k++)
                {
                    gotoTable[i][j][k] = s.readInt();
                }
                }
            }

            // read errorMessages
            length = s.readInt();
            errorMessages = new String[length];
            for(int i = 0; i < errorMessages.length; i++)
            {
                length = s.readInt();
                StringBuffer buffer = new StringBuffer();

                for(int j = 0; j < length; j++)
                {
                buffer.append(s.readChar());
                }
                errorMessages[i] = buffer.toString();
            }

            // read errors
            length = s.readInt();
            errors = new int[length];
            for(int i = 0; i < errors.length; i++)
            {
                errors[i] = s.readInt();
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
        }
    }
}
